# SoSFRotation Class Reference
[Field classes]

`#include <Inventor/fields/SoSFRotation.h>`

Inheritance diagram for SoSFRotation:

List of all members.

## Detailed Description

The SoSFRotation class is a container for an SbRotation.

This field is used where nodes, engines or other field containers needs to store a single rotation definition.

Fields of this type stores their value to file as a rotation axis vector plus a rotation angle: "axis0 axis1 axis2 angle".

Note that there is one very common mistake that is easy to make when setting the value of an SoSFRotation field, and that is to inadvertently use the wrong SbRotation constructor. This example should clarify the problem:

      mytransformnode->rotation.setValue(0, 0, 1, 1.5707963f);

The programmer clearly tries to set a PI/2 rotation around the Z axis, but this will fail, as the SbRotation constructor invoked above is the one that takes as arguments the 4 floats of a quaternion. What the programmer almost certainly wanted to do was to use the SbRotation constructor that takes a rotation vector and a rotation angle, which is invoked like this:

      mytransformnode->rotation.setValue(SbVec3f(0, 0, 1), 1.5707963f);

See also:
  SoMFRotation

## Public Member Functions

void | getValue (SbVec3f &axis, float &angle) const
void | setValue (const float q0, const float q1, const float q2, const float q3)
void | setValue (const float q[4])
void | setValue (const SbVec3f &axis, const float angle)

## Static Public Member Functions

void | initClass (void)

## Member Function Documentation

void SoSFRotation::initClass | ( | void |  | ) | `[static]`

| Internal method called upon initialization of the library (from SoDB::init()) to set up the type system. Reimplemented from SoSField.

void SoSFRotation::getValue | ( | SbVec3f & | axis,
|  | float & | angle
| ) | const

| Return value of rotation as an axis and an angle around this axis.

void SoSFRotation::setValue | ( | const float | q0,
|  | const float | q1,
|  | const float | q2,
|  | const float | q3
| ) |

| Set the rotation from a set of quaternion values.

void SoSFRotation::setValue | ( | const float | q[4] | ) |

| Set the rotation from a set of quaternion values.

void SoSFRotation::setValue | ( | const SbVec3f & | axis,
|  | const float | angle
| ) |

| Set the rotation from an axis and an angle around this axis.

The documentation for this class was generated from the following files:

- SoSFRotation.h
- SoSFRotation.cpp